# Perl routine to take a TR number as written in a refer file
# into a standard Dienst document id.  This will be different
# at each site, as it must cope with local variances in usage
# and must supply the correct publisher symbol, which probably
# is not in the refer file

# This version is for Rochester.

$publisher = "URCSD";

# $number is the contents of the %R tag
# global input $line is line number.
sub canonicalize_report_number {
    local ($number) = @_;
    local ($n, $m);
    local ($id);
    if ($number =~ /^TR ([0-9]+)(.*)$/) {
	$n = $1;
	$m = $2;
	$id = "$publisher//TR-$n";
	if (! ($m eq "" ||
	       $m =~ /^ [Rr]evised$/ ||
	       $m eq " and Ph.D. Thesis" ||
	       $m eq " (Thesis Proposal)"
	       )) {
	    print STDERR "Warning, Interpreting report number $number as $id (line $line)\n";}}
    elsif ($number =~ /^(TRAINS )?TN ([-0-9]+)$/) {
	$id = "$publisher//TRAINS-TN-$2";}
    else {
	print STDERR "Could not parse $number into a document id (line $line)\n";}
    $id;}
	
